--
-- FarmingTablet - Storage Overview
--
-- @Interface: 1.5.1.0 b1580
-- @Author: kevink98 & GtX
-- @TabletAuthor: kevink98 
-- @Date: 25.09.2017
-- @Version: 1.0.0
--
-- @Support: http://ls-modcompany.com
-- @mCompanyInfo: http://mcompany-info.de/
--

FarmingTablet_App_StorageOverview = {}
FarmingTablet_App_StorageOverview.dir = g_currentModDirectory
addModEventListener(FarmingTablet_App_StorageOverview)

FarmingTablet_App_StorageOverview.name = "StorageOverview"
FarmingTablet_App_StorageOverview.version = "1.1.0.0"
print("   [FarmingTablet - StorageOverview] load " .. tostring(FarmingTablet_App_StorageOverview.version))

function FarmingTablet_App_StorageOverview:loadMap()
	g_farmingTablet.utils.loadLanguageText(FarmingTablet_App_StorageOverview.name, FarmingTablet_App_StorageOverview.dir.."languageXML.xml")

	local appData = {}
	appData.name = FarmingTablet_App_StorageOverview.name
	appData.nameOfApp = g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_StorageOverview.name,"nameApp")
	appData.nameAppstoreButton = g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_StorageOverview.name,"nameButton")
	appData.isBuyable = true
	appData.appCategoryDefault = 2
	appData.startWindow = "StorageOverview_page"
	appData.author = "kevink98, GtX"
	appData.version = "1.1.0.0"
	appData.priceForAppstore = 3000
	appData.iconImage = createImageOverlay(FarmingTablet_App_StorageOverview.dir .."stockOverview.dds")
	appData.descLine1 = g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_StorageOverview.name,"descLine1")
	appData.descLine2 = g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_StorageOverview.name,"descLine2")
	appData.descLine3 = g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_StorageOverview.name,"descLine3")

	appData.modDir = FarmingTablet_App_StorageOverview.dir
	g_farmingTablet.modApp.newApp(appData)

	g_farmingTablet.utils.addNew_Category_Window(FarmingTablet_App_StorageOverview, FarmingTablet_App_StorageOverview.name, "StorageOverview_page", "STORAGEOVERVIEW_PAGE", true,true,true)
	g_farmingTablet.utils.loadOverlay(FarmingTablet_App_StorageOverview.name, FarmingTablet_App_StorageOverview.dir , "overlays.xml")
	g_farmingTablet.utils.loadButtons(FarmingTablet_App_StorageOverview.name, FarmingTablet_App_StorageOverview.dir .. "buttons.xml", FarmingTablet_App_StorageOverview)

	FarmingTablet_App_StorageOverview.data = {}
	FarmingTablet_App_StorageOverview.mapText = {}
	FarmingTablet_App_StorageOverview.activeSilo = 1
	FarmingTablet_App_StorageOverview.productState = 1

	if fileExists(g_currentMission.baseDirectory.."modDesc.xml") then
		local xml = loadXMLFile("modDesc",g_currentMission.baseDirectory.."modDesc.xml","modDesc")
		local mapXml = loadXMLFile("map",g_currentMission.baseDirectory..getXMLString(xml, "modDesc.maps.map".."#configFilename"),"map")
		local filename = getXMLString(mapXml, "map.ingameMap".."#filename")
		FarmingTablet_App_StorageOverview.baseMapPDAwidth = getXMLInt(mapXml, "map.ingameMap".."#width")

		local i = 0
		while true do
			local key = string.format("modDesc.l10n.text(%d)",i)
			if not hasXMLProperty(xml,key) then
				break
			end
			FarmingTablet_App_StorageOverview.mapText[getXMLString(xml,key.."#name")] = getXMLString(xml, key.."."..g_languageShort)
			i = i + 1
		end
	else
		FarmingTablet_App_StorageOverview.baseMapPDAwidth = 2048
	end

	FarmingTablet_App_StorageOverview.data = {}
	local loadApp = function(...) return FarmingTablet_App_StorageOverview:openApp(...) end
	g_farmingTablet.addAppToOpen(loadApp, appData.startWindow)

	FarmingTablet_App_StorageOverview.mousePosition = {0, 0}
	FarmingTablet_App_StorageOverview.mapPointMarked = {}
	FarmingTablet_App_StorageOverview.mouseOverActive = false
	FarmingTablet_App_StorageOverview.canUpdate = false
end

function FarmingTablet_App_StorageOverview:openApp()
	if FarmingTablet_App_StorageOverview.pda == nil then
		FarmingTablet_App_StorageOverview.pda = createImageOverlay(g_currentMission.ingameMap.mapOverlay.filename)
	end

	FarmingTablet_App_StorageOverview.mousePosition = {0, 0}
	FarmingTablet_App_StorageOverview.mapPointMarked = {}
	FarmingTablet_App_StorageOverview.mouseOverActive = false
end

function FarmingTablet_App_StorageOverview:draw_StorageOverview_page()
	FarmingTablet_App_StorageOverview.canUpdate = true
	renderOverlay(g_farmingTablet.button.getOverlayByModus_name("image", "backScreenStorageOverview").id,0.008,0.0163,1,0.964)
	g_farmingTablet.button.drawButtonByCategory("STORAGEOVERVIEW_PAGE")

	FarmingTablet_App_StorageOverview.data = FarmingTablet_App_StorageOverview:getData()
	if FarmingTablet_App_StorageOverview.data.objects[FarmingTablet_App_StorageOverview.activeSilo] ~= nil then
		if table.getn(FarmingTablet_App_StorageOverview.data.objects[FarmingTablet_App_StorageOverview.activeSilo].tabletData) > 5 then
			g_farmingTablet.button.getButtonByApp(FarmingTablet_App_StorageOverview.name, "Product_up").visible = true
			g_farmingTablet.button.getButtonByApp(FarmingTablet_App_StorageOverview.name, "Product_down").visible = true
		else
			g_farmingTablet.button.getButtonByApp(FarmingTablet_App_StorageOverview.name, "Product_up").visible = false
			g_farmingTablet.button.getButtonByApp(FarmingTablet_App_StorageOverview.name, "Product_down").visible = false
		end
	else
		g_farmingTablet.button.getButtonByApp(FarmingTablet_App_StorageOverview.name, "Product_up").visible = false
		g_farmingTablet.button.getButtonByApp(FarmingTablet_App_StorageOverview.name, "Product_down").visible = false
	end

	if FarmingTablet_App_StorageOverview.data.objects[FarmingTablet_App_StorageOverview.activeSilo] ~= nil then
		local object = FarmingTablet_App_StorageOverview.data.objects[FarmingTablet_App_StorageOverview.activeSilo]
		FarmingTablet_App_StorageOverview:doUpdates(object)
		-- Silo Location
		renderOverlay(FarmingTablet_App_StorageOverview.pda, 0.122,0.199,0.27,0.48)
		local x,_,z = getWorldTranslation(object.node)
		x = 0.257 + (0.27 / FarmingTablet_App_StorageOverview.baseMapPDAwidth * x) - 0.0025
		z = 0.439 + (0.48 / FarmingTablet_App_StorageOverview.baseMapPDAwidth * -z) - 0.005
		if object.id == FarmingTablet_App_StorageOverview.activeSilo then
			renderOverlay(g_farmingTablet.button.getOverlayByModus_name("image", "onStorageOverview").id,x,z,0.005,0.01)
		end

		local text = string.format("%s / %s  %s",FarmingTablet_App_StorageOverview.activeSilo,table.getn(FarmingTablet_App_StorageOverview.data.objects), object.name)
		local x = 0.649 - getTextWidth(0.032, text) / 2
		local fixedTotal = 0
		if object.totalWorth ~= nil then
			fixedTotal = object.totalWorth
		else
			fixedTotal = 0
		end		

		local factor = g_currentMission.missionInfo.buyPriceMultiplier * object.costPerDay
		local cost = 0
		for _,lvl in pairs(object.tabletData) do
            cost = cost + lvl.level * factor
        end		
		
		setTextColor(0.106,0.240,0.038,1)
		setTextBold(true)
		renderText(x, 0.71, 0.032, text)
		setTextBold(false)
		setTextColor(0.128,0.128,0.128,1)
		renderText(0.15,0.732,0.021, g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_StorageOverview.name,"silo"))
		renderText(0.245,0.732,0.021, g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_StorageOverview.name,"bestSell"))
		setTextColor(1,1,1,1)
		renderText(0.43,0.66,0.026,g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_StorageOverview.name,"capacity") .. g_i18n:formatNumber(object.capacity, 0) .. " l")
		renderText(0.43,0.59,0.028,g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_StorageOverview.name,"headerOne"))
		setTextAlignment(RenderText.ALIGN_RIGHT)
		renderText(0.86,0.59,0.028,g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_StorageOverview.name,"headerTwo"))
		renderText(0.86,0.195,0.028,g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_StorageOverview.name,"totalValue") .. g_i18n:formatMoney(fixedTotal, 0))
		renderText(0.86,0.66,0.026,g_farmingTablet.utils.getTextByAppName(FarmingTablet_App_StorageOverview.name,"costPerDay") .. g_i18n:formatMoney(cost, 0))
		setTextAlignment(RenderText.ALIGN_LEFT)
		
		FarmingTablet_App_StorageOverview.mouseOverActive = false		
		for i=0, math.min(table.getn(object.tabletData), 5) do
			local v = object.tabletData[i + FarmingTablet_App_StorageOverview.productState - 1]

			if FarmingTablet_App_StorageOverview:buttonHover(FarmingTablet_App_StorageOverview.mousePosition[1], FarmingTablet_App_StorageOverview.mousePosition[2], 0.42, 0.89, 0.510-(i*0.05), 0.540-(i*0.05)) then
				if v.sellPoint ~= nil then
					FarmingTablet_App_StorageOverview.mouseOverActive = true
					if not FarmingTablet_App_StorageOverview.mapPointMarked[i] then
						renderOverlay(g_farmingTablet.button.getOverlayByModus_name("image", "mouseButton").id,0.43,(0.510-(i*0.05)),0.0153,0.03)
					end
					if InputBinding.hasEvent(InputBinding.TARGET_SELL_POINT) then
						FarmingTablet_App_StorageOverview:onClickPrice(v)
					end
				end

				if v.storedValue ~= nil then
					renderText(0.46,(0.515-(i*0.05)),0.03, v.bestLocation)
					setTextAlignment(RenderText.ALIGN_RIGHT)
					renderText(0.85,(0.515-(i*0.05)),0.03,g_i18n:formatMoney(v.storedValue))
					setTextAlignment(RenderText.ALIGN_LEFT)
				end
			else
				renderText(0.46,(0.515-(i*0.05)),0.03, v.fillType)
				setTextAlignment(RenderText.ALIGN_RIGHT)
				renderText(0.85,(0.515-(i*0.05)),0.03, g_i18n:formatNumber(v.level, 0) .. " l")
				setTextAlignment(RenderText.ALIGN_LEFT)
			end

			-- Sell Point Location.
			if FarmingTablet_App_StorageOverview.mapPointMarked[i] then
				local pulse = Utils.clamp(math.cos( 9.0 * (g_currentMission.time/2000) ), 0, 1)
				if v.sellPoint ~= nil then
					local x,_,z = getWorldTranslation(v.sellPoint.rootNode)
					x = 0.257 + (0.27 / FarmingTablet_App_StorageOverview.baseMapPDAwidth * x) - 0.0025
					z = 0.439 + (0.48 / FarmingTablet_App_StorageOverview.baseMapPDAwidth * -z) - 0.005
					if pulse > 0 then
						renderOverlay(g_farmingTablet.button.getOverlayByModus_name("image", "onSellPoint").id,x,z,0.005,0.01)
					end
					renderOverlay(g_farmingTablet.button.getOverlayByModus_name("image", "onSellPointMenu").id,0.43,(0.510-(i*0.05)),0.0153,0.03)
				end
			end
		end
	else
		renderText(0.46,0.721,0.026,"Keine Silos gefunden / No Silos Found")
	end
end

function FarmingTablet_App_StorageOverview:getData()
	local data = {}
	data.numObjects = 0
	data.objects = {}
	if g_currentMission.ownedItems ~= nil then
		local targetNodeUsed = {}
		for target, _ in pairs(g_currentMission.siloTriggers) do
			local canAddSilo = true
			local fillLevels = {}
			local capacity = 0
			local costsPerFillLevelAndDay = 0
			local name = ""
			local rootNode = nil
			local source = nil

			for siloSource,_ in pairs(target.siloSources) do
				-- Trying to stop adding double silo points like Train Stations.
				rootNode = siloSource.rootNode
				source = rootNode
				for _, id in pairs (targetNodeUsed) do
					if id == rootNode then
						canAddSilo = false
					end
				end				
				
				if canAddSilo then
					if siloSource.ownsRootNode then
						if costsPerFillLevelAndDay == 0 then
							costsPerFillLevelAndDay = siloSource.costsPerFillLevelAndDay
						end
					end				

					if siloSource.storageName == "hayLoft" then
						name = "Placeable Silo"
					elseif siloSource.storageName == "Storage" then
						name = FarmingTablet_App_StorageOverview:getCorrectName(target.stationName)
					else
						if siloSource.storageName ~= nil then
							name = FarmingTablet_App_StorageOverview:getCorrectName(siloSource.storageName)
						else
							name = FarmingTablet_App_StorageOverview:getCorrectName(target.storageName)
						end
					end
	
					for fillType, fillLevel in pairs(siloSource.fillLevels) do
						fillLevels[fillType] = Utils.getNoNil(fillLevels[fillType], 0) + fillLevel
					end
	
					capacity = capacity + siloSource.capacity
				end
			end

			if canAddSilo then
				data.numObjects = data.numObjects + 1
				targetNodeUsed[data.numObjects] = source
				data.objects[data.numObjects] = {}
				data.objects[data.numObjects].tabletData = {}
				data.objects[data.numObjects].totalWorth = 0
				data.objects[data.numObjects].node = rootNode
				data.objects[data.numObjects].id = data.numObjects
				data.objects[data.numObjects].name = name
				data.objects[data.numObjects].capacity = capacity
				data.objects[data.numObjects].costPerDay = costsPerFillLevelAndDay

				local i = 0
				for typ, lvl in pairs(fillLevels) do
					data.objects[data.numObjects].tabletData[i] = {}
					data.objects[data.numObjects].tabletData[i].fillType = FillUtil.fillTypeIndexToDesc[typ].nameI18N
					data.objects[data.numObjects].tabletData[i].level = lvl

					-- Create and sort prices list.
					local priceTable = {}
					local priceTableNames = {}
					local price = 0
					for _, trigger in pairs(g_currentMission.tipTriggers) do
						if trigger.isSellingPoint then
							if trigger.fillTypePrices[typ] ~= nil and trigger.fillTypePrices[typ] > 0 then								
								local sellName = FarmingTablet_App_StorageOverview:getCorrectName(trigger.stationName)
								price = {value = Utils.getNoNil(trigger:getEffectiveFillTypePrice(typ),0), name = sellName, id = trigger} -- Check all sell triggers for prices, name and id.
								table.insert(priceTable, price)
							end
						end
					end
					table.sort(priceTable, function(a,b) return a.value < b.value end) -- Sort table from lowest to highest price.
					local count = table.getn(priceTable) -- Table size tells us the highest number since we sorted it this way :-)
					if count > 0 then	
						local setPrice = priceTable[count].value*1000 -- Price per 1000 liters.
						local factor = lvl/1000 -- How many groups of 1000 liters do we have?
						local  valueFactor = setPrice*factor -- Total best sale value of stored crop type.
						data.objects[data.numObjects].tabletData[i].storedValue = valueFactor -- Price
						data.objects[data.numObjects].tabletData[i].bestLocation = priceTable[count].name -- Location
						data.objects[data.numObjects].tabletData[i].sellPoint = priceTable[count].id -- ID of Sell Point so we can target it on the miniMap.
						data.objects[data.numObjects].totalWorth = data.objects[data.numObjects].totalWorth + valueFactor-- What is the best available total value of all fill types in the silo combined.
					else
						data.objects[data.numObjects].tabletData[i].storedValue = 0.0 -- Fake Price
						data.objects[data.numObjects].tabletData[i].bestLocation = "N/A" -- N/A Location
						data.objects[data.numObjects].tabletData[i].sellPoint = nil
					end
					i = i + 1
				end
			end
		end
	end
	return data
end

function FarmingTablet_App_StorageOverview:getCorrectName(sentName)
	-- Sort of a fix if l10n is missing for the name requested.
	local l10n = g_i18n
	local name = sentName
	
	if g_currentMission.missionInfo.customEnvironment ~= nil then
		l10n = _G[g_currentMission.missionInfo.customEnvironment].g_i18n
	end

	if l10n:hasText(name) then
		name = l10n:getText(name)
	end
	
	return name
end

function FarmingTablet_App_StorageOverview:onActiveClick_Product_up()
	FarmingTablet_App_StorageOverview.productState = FarmingTablet_App_StorageOverview.productState - 1
	if FarmingTablet_App_StorageOverview.productState < 1 then
		FarmingTablet_App_StorageOverview.productState = 1
	end
end
function FarmingTablet_App_StorageOverview:onActiveClick_Product_down()
	FarmingTablet_App_StorageOverview.productState = FarmingTablet_App_StorageOverview.productState + 1
	if table.getn(FarmingTablet_App_StorageOverview.data.objects[FarmingTablet_App_StorageOverview.activeSilo].tabletData) < (FarmingTablet_App_StorageOverview.productState + 5) then
		FarmingTablet_App_StorageOverview.productState = FarmingTablet_App_StorageOverview.productState - 1
	end
end

function FarmingTablet_App_StorageOverview:onActiveClick_Menue_left()
	if FarmingTablet_App_StorageOverview.activeSilo - 1 > 0 then
		FarmingTablet_App_StorageOverview.activeSilo = FarmingTablet_App_StorageOverview.activeSilo - 1
		FarmingTablet_App_StorageOverview.productState = 1
	end
end
function FarmingTablet_App_StorageOverview:onActiveClick_Menue_right()
	if table.getn(FarmingTablet_App_StorageOverview.data.objects) >= FarmingTablet_App_StorageOverview.activeSilo + 1 then
		FarmingTablet_App_StorageOverview.activeSilo = FarmingTablet_App_StorageOverview.activeSilo + 1
		FarmingTablet_App_StorageOverview.productState = 1
	end
end

function FarmingTablet_App_StorageOverview:doUpdates(object)
	-- When app is open keep checking the HotSpots for changes made by users selecting parts of the inGame menu..
	for _, trigger in pairs(g_currentMission.tipTriggers) do
		if g_currentMission.currentMapTargetHotspot == trigger.mapHotspot then
			for i=0, math.min(table.getn(object.tabletData), 5) do
				local location = object.tabletData[i + FarmingTablet_App_StorageOverview.productState - 1]
				if location.sellPoint ~= nil and location.sellPoint == trigger then
					if not FarmingTablet_App_StorageOverview.mapPointMarked[i] then
						FarmingTablet_App_StorageOverview.mapPointMarked[i] = true
					end
				else
					if FarmingTablet_App_StorageOverview.mapPointMarked[i] then
						FarmingTablet_App_StorageOverview.mapPointMarked[i] = false
					end
				end
			end
		end
	end

	-- Let users scroll fillTypes with the mouse if they are greater then 6.
	if InputBinding.hasEvent(InputBinding.CAMERA_ZOOM_OUT) then
		FarmingTablet_App_StorageOverview:onActiveClick_Product_down()		
	elseif InputBinding.hasEvent(InputBinding.CAMERA_ZOOM_IN) then
		FarmingTablet_App_StorageOverview:onActiveClick_Product_up()
	end

end


function FarmingTablet_App_StorageOverview:mouseEvent(posX, posY, isDown, isUp, button)
	FarmingTablet_App_StorageOverview.mousePosition[1] = posX
	FarmingTablet_App_StorageOverview.mousePosition[2] = posY
end

function FarmingTablet_App_StorageOverview:buttonHover(mpX, mpY, xStart, xEnd, yStart, yEnd)
	if mpX > xStart and mpX < xEnd and mpY > yStart and mpY < yEnd then
		return true
	else
		return false
	end
end

function FarmingTablet_App_StorageOverview:onClickPrice(location)
	for _, trigger in pairs(g_currentMission.tipTriggers) do
		if location.sellPoint ~= nil and location.sellPoint == trigger then
			if g_currentMission.currentMapTargetHotspot == trigger.mapHotspot then
				g_currentMission:setMapTargetHotspot(nil)
			else
				g_currentMission:setMapTargetHotspot(trigger.mapHotspot)
			end
		end
	end
end

function FarmingTablet_App_StorageOverview:update(dt)
end
function FarmingTablet_App_StorageOverview:saveMap()
end
function FarmingTablet_App_StorageOverview:keyEvent(unicode, sym, modifier, isDown)
end
function FarmingTablet_App_StorageOverview:draw()
end
function FarmingTablet_App_StorageOverview:delete()
end
function FarmingTablet_App_StorageOverview:deleteMap()
end